#include <bits/stdc++.h>
using namespace std;

int main()
{
	int N, Q;
	cin >> N >> Q;
	
	int A[N];
	for (int i=0; i<N; i++)
	{
		cin >> A[i];
	}
	
	int L[Q]; int R[Q];
	
	for (int i=0; i<Q; i++)
	{
		cin >> L[i] >> R[i];
	}
	
	for (int m=0; m<Q; m++)
	{
		int s = 0;
		for(int i=L[m]; i<R[m]; i++)
		{
			for(int j=L[m]; j<R[m]; j++)
			{
				if (A[i] != A[j])
				{
					int k = log2(A[i]);
					int m = 1 << k;
					k = log2(A[j]);
					int n = 1<<k;
					if ((m&n) > (m^n)) s++;
				}
			}
		}	
		cout << s << endl;
	}
}